<?php

namespace Importacao\Logic\Integracao\Mastermaq\Classes;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Migracao;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Entities\Transferencia;

class GeraTransferencia extends Migracao{

    const NR_MOTIVO_TRANFERENCIA = 16;
    const NR_ESTRUTURA = 187;
    const NR_TIPO_ESTRUTURA = 1;
    const MOTIVO_TRANFERENCIA = 16;


    public function __construct($path) {
      parent::__construct($path);
include_once 'Migracao.php';
      $this->file_name = 'Transferencia';
      $this->setColumns();
    }
    
    public function createInfo($info) {

        sort($info);
        $n = count($info);

        for ($c=0; $c < $n; $c++) { 
            $transf = new Transferencia();

            if(($c<$n-1)&&($info[$c]['FUNCC'] == $info[$c+1]['FUNCC'])){

                $transf->setNr_vinculo($info[$c]['FUNCC']);
                $transf->setNr_tipo_transferencia();
                $transf->setNr_motivo_transferencia(self::NR_MOTIVO_TRANFERENCIA);
                $transf->setNr_estrutura(self::NR_ESTRUTURA);
                $transf->setObervacao($info[$c]['MOTIVO']);
                $transf->setDt_fim_movimentacao($info[$c+1]['DATA']);
                $transf->setDt_inicio_movimentacao($info[$c]['DATA']);
                $transf->setNr_tipo_estrutura(self::NR_TIPO_ESTRUTURA);
                $transf->setDt_mov_retroativa();
                $transf->setMotivo_da_transferencia(self::MOTIVO_TRANFERENCIA);

            }else{
                $transf->setNr_vinculo($info[$c]['FUNCC']);
                $transf->setNr_tipo_transferencia($info[$c]['TIPO']);
                $transf->setNr_motivo_transferencia(self::NR_MOTIVO_TRANFERENCIA);
                $transf->setNr_estrutura(self::NR_ESTRUTURA);
                $transf->setObervacao($info[$c]['MOTIVO']);
                $transf->setDt_fim_movimentacao();
                $transf->setDt_inicio_movimentacao($info[$c]['DATA']);
                $transf->setNr_tipo_estrutura(self::NR_TIPO_ESTRUTURA);
                $transf->setDt_mov_retroativa();
                $transf->setMotivo_da_transferencia(self::MOTIVO_TRANFERENCIA);
            }

            $this->objects[] = $transf;  
        }

    }

    public function setColumns() {
        $this->columns[] = 'Nr. Vínculo';
        $this->columns[] = 'Nr. Tipo Transferência';
        $this->columns[] = 'Nr. Motivo Transferência';
        $this->columns[] = 'Nr. Estrutura';
        $this->columns[] = 'Obervação';
        $this->columns[] = 'Dt. Fim Movimentação';
        $this->columns[] = 'Dt. Início Movimentação';
        $this->columns[] = 'Nr. Tipo Estrutura';
        $this->columns[] = 'Dt. Mov. Retroativa';
        $this->columns[] = 'Motivo da Transferência';
    }
}

?>
