/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3924_CDPSTP0.SQL

Descrio:
Rotina para gerao de Ordem de Produo (OP) para os semiacabados industrializados
e seus semiacabados, etc...

@C:\Web_585\Sql\End_Conv\Oracle\3924_CDPSTPO_GERA_OP_SEMIACABADO.SQL

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');
-- raise_application_error(-20501, '**'||V_NRORDPROD||'**', True);

Criao:
15/07/2015 - Srgio Pow Gomes
*/

create or replace
PROCEDURE GERA_OP_SEMIACABADO
   (P_CDFILIAL        IN ORDPRODUCAO.CDFILIAL%TYPE,
    P_CDPRODUTO       IN ORDPRODUCAO.CDPRODUTO%TYPE,
    P_CDPROCFABRIC    IN ORDPRODUCAO.CDPROCFABRIC%TYPE,
    P_IDSITORDPROD    IN ORDPRODUCAO.IDSITORDPROD%TYPE,
    P_IDTIPORDPROD    IN ORDPRODUCAO.IDTIPORDPROD%TYPE,
    P_DTGERORDPROD    IN ORDPRODUCAO.DTGERORDPROD%TYPE,
    P_DTVALIDADE      IN ORDPRODUCAO.DTGERORDPROD%TYPE,
    P_QTAPRODPREOP    IN ORDPRODUCAO.QTAPRODPREOP%TYPE,
    P_DSORDPROD       IN ORDPRODUCAO.DSORDPROD%TYPE,
    P_CDPLANPRODOP    IN ORDPRODUCAO.CDPLANPRODOP%TYPE,
    P_IDCONFIRMAOP    IN ORDPRODUCAO.IDCONFIRMAOP%TYPE,
    P_NRPEDIDO        IN ORDPRODUCAO.NRPEDIDO%TYPE,
    P_NRITEMPED       IN ORDPRODUCAO.NRITEMPED%TYPE
   ) AS
   V_DSNUMELOTEPR   PARAMAN.DSNUMELOTEPR%TYPE;
   V_DSSEQULOTEPR   PARAMAN.DSSEQULOTEPR%TYPE;
   V_SEQNRORDPROD   VARCHAR2(20);
   V_NRORDPROD      ORDPRODUCAO.NRORDPROD%TYPE;
   V_NRLOTEESTQ     LOTE.NRLOTEESTQ%TYPE;
   V_NRSUBLOTE      LOTE.NRSUBLOTE%TYPE;
   V_NRORDENASUBOP  CALEPRODMRP.NRORDENAOP%TYPE;
   V_IDSUBOPSEMIACA PARAMAN.IDSUBOPSEMIACA%TYPE;
   V_IDENTRSEQ      CHAR;
   V_IDUTEQUIPLAPROD PARAMAN.IDUTEQUIPLAPROD%TYPE;
   V_QTPADPROCFAB   FLOAT;
   V_CONTGEROP      FLOAT;
   V_QTDEOP         FLOAT;
   V_IDTPPROPOPF    VARCHAR2(1);
   V_IDTPARREDPF    VARCHAR2(1);
   V_CONTADOR       NUMBER;
   V_CONTADOR2      NUMBER;
   V_NRLOTEEXIST    LOTE.NRLOTEESTQ%TYPE;
   V_CDPRODEMANDA   PRODUTO.CDPRODUTO%TYPE;
   V_QTSEMIACAB     FLOAT;
   V_QTESTOQUE      FLOAT;
BEGIN
   /* Verifica parmetros do manufatura */
   SELECT
      MAX(DSNUMELOTEPR),
      MAX(DSSEQULOTEPR),
      NVL(MAX(IDSUBOPSEMIACA),'N'),
      MAX(NVL(IDENTRSEQLOTE,'N')),
      MAX(NVL(IDUTEQUIPLAPROD, 'N'))
   INTO
      V_DSNUMELOTEPR,
      V_DSSEQULOTEPR,
      V_IDSUBOPSEMIACA,
      V_IDENTRSEQ,
      V_IDUTEQUIPLAPROD
   FROM
      PARAMAN M, PARAMFILIAL F
   WHERE
      M.CDFILIAL = P_CDFILIAL    AND
      M.CDFILIAL = F.CDFILIAL;

   SELECT QTPADPROCFAB, IDTPPROPOPF, IDTPARREDPF
      INTO V_QTPADPROCFAB, V_IDTPPROPOPF, V_IDTPARREDPF
      FROM PROCFABRICA
     WHERE CDFILIAL  = P_CDFILIAL
       AND CDPRODUTO = P_CDPRODUTO
       AND IDPROFABPADR = 'S';

   V_CONTADOR  := 1;
   V_CONTADOR2 := 1;
   V_CONTGEROP := 0;

   IF V_IDTPPROPOPF = 'N' THEN
      V_CONTGEROP := P_QTAPRODPREOP / V_QTPADPROCFAB;
      V_CONTGEROP := TRUNC(V_CONTGEROP + 1);
      V_QTDEOP    := P_QTAPRODPREOP;

      FOR V_CONTADOR IN V_CONTADOR2..V_CONTGEROP LOOP
         IF (V_CONTADOR <> V_CONTGEROP) THEN
            V_QTDEOP := V_QTPADPROCFAB;
         ELSE
            V_QTDEOP :=  P_QTAPRODPREOP - (V_QTPADPROCFAB * (V_CONTGEROP - 1));
         END IF;

         IF V_QTDEOP > 0 THEN
            /* Gera o nmero do Lote de Produo */
            PRXLOTEPROD(P_CDFILIAL, P_DTVALIDADE, P_CDPRODUTO, V_NRLOTEESTQ);
               /* Gera o nmero da OP/SubOP */
            NOVO_CODIGO_SC('NRORDPROD'||P_CDFILIAL, V_SEQNRORDPROD, 1);
            V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
            V_NRORDENASUBOP := '0';
            V_NRSUBLOTE     := ' ';

            SELECT
               MAX(NRLOTEESTQ)
            INTO
               V_NRLOTEEXIST
            FROM
               LOTE
            WHERE
               CDFILIAL     = P_CDFILIAL    AND
               CDPRODUTO    = P_CDPRODUTO   AND
               NRLOTEESTQ   = V_NRLOTEESTQ;

            IF V_NRLOTEEXIST IS NULL THEN
               INSERT INTO LOTE
                   (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
                   DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
               VALUES
                   (P_CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, P_CDPRODUTO, 'I',
                    P_DTGERORDPROD, P_DTVALIDADE, '1', P_CDPLANPRODOP);
            END IF;

            INSERT INTO ORDPRODUCAO
                 (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO, CDPROCFABRIC,
                   IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
                  DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
                  NRPEDIDO, NRITEMPED)
            VALUES
                 (P_CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, P_CDPRODUTO,  P_CDPROCFABRIC,
                  P_IDSITORDPROD, P_IDTIPORDPROD, P_DTGERORDPROD, V_QTDEOP,
                  P_DTGERORDPROD, V_NRLOTEESTQ, V_NRSUBLOTE, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP,
                  P_NRPEDIDO, P_NRITEMPED);
         END IF;
      END LOOP;
   ELSE
      IF V_IDTPPROPOPF = 'L' THEN
         IF V_IDTPARREDPF = '1' THEN
            V_CONTADOR  := 1;
            V_CONTADOR2 := 1;

            IF (MOD(P_QTAPRODPREOP, V_QTPADPROCFAB) <> 0) THEN
               V_QTDEOP := ((TRUNC(P_QTAPRODPREOP / V_QTPADPROCFAB) + 1) * V_QTPADPROCFAB);
            ELSE
               V_QTDEOP := ((P_QTAPRODPREOP / V_QTPADPROCFAB) * V_QTPADPROCFAB);
            END IF;

            V_CONTGEROP := V_QTDEOP / V_QTPADPROCFAB;

            FOR V_CONTADOR IN V_CONTADOR2..V_CONTGEROP LOOP
               V_QTDEOP := V_QTPADPROCFAB;

               /* Gera o nmero do Lote de Produo */
               PRXLOTEPROD(P_CDFILIAL, P_DTVALIDADE, P_CDPRODUTO, V_NRLOTEESTQ);
                  /* Gera o nmero da OP/SubOP */
               NOVO_CODIGO_SC('NRORDPROD'||P_CDFILIAL, V_SEQNRORDPROD, 1);
               V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
               V_NRORDENASUBOP := '0';
               V_NRSUBLOTE     := ' ';

               SELECT
                  MAX(NRLOTEESTQ)
               INTO
                  V_NRLOTEEXIST
               FROM
                  LOTE
               WHERE
                  CDFILIAL     = P_CDFILIAL    AND
                  CDPRODUTO    = P_CDPRODUTO   AND
                  NRLOTEESTQ   = V_NRLOTEESTQ;

               IF V_NRLOTEEXIST IS NULL THEN
                  INSERT INTO LOTE
                      (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
                      DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
                  VALUES
                      (P_CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, P_CDPRODUTO, 'I',
                       P_DTGERORDPROD, P_DTVALIDADE, '1', P_CDPLANPRODOP);
               END IF;

               INSERT INTO ORDPRODUCAO
                    (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO, CDPROCFABRIC,
                      IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
                     DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
                     NRPEDIDO, NRITEMPED)
               VALUES
                    (P_CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, P_CDPRODUTO,  P_CDPROCFABRIC,
                     P_IDSITORDPROD, P_IDTIPORDPROD, P_DTGERORDPROD, V_QTDEOP,
                     P_DTGERORDPROD, V_NRLOTEESTQ, V_NRSUBLOTE, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP,
                     P_NRPEDIDO, P_NRITEMPED);
            END LOOP;
         ELSE
            IF V_IDTPARREDPF = '2' THEN
               V_CONTADOR  := 1;
               V_CONTADOR2 := 1;

               V_QTDEOP := ((TRUNC(P_QTAPRODPREOP / V_QTPADPROCFAB)) * V_QTPADPROCFAB);
               V_CONTGEROP := V_QTDEOP / V_QTPADPROCFAB;

               FOR V_CONTADOR IN V_CONTADOR2..V_CONTGEROP LOOP
                   V_QTDEOP := V_QTPADPROCFAB;

                  /* Gera o nmero do Lote de Produo */
                  PRXLOTEPROD(P_CDFILIAL, P_DTVALIDADE, P_CDPRODUTO, V_NRLOTEESTQ);
                     /* Gera o nmero da OP/SubOP */
                  NOVO_CODIGO_SC('NRORDPROD'||P_CDFILIAL, V_SEQNRORDPROD, 1);
                  V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
                  V_NRORDENASUBOP := '0';
                  V_NRSUBLOTE     := ' ';

                  SELECT
                     MAX(NRLOTEESTQ)
                  INTO
                     V_NRLOTEEXIST
                  FROM
                     LOTE
                  WHERE
                     CDFILIAL     = P_CDFILIAL    AND
                     CDPRODUTO    = P_CDPRODUTO   AND
                     NRLOTEESTQ   = V_NRLOTEESTQ;

                  IF V_NRLOTEEXIST IS NULL THEN
                     INSERT INTO LOTE
                         (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
                         DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
                     VALUES
                         (P_CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, P_CDPRODUTO, 'I',
                          P_DTGERORDPROD, P_DTVALIDADE, '1', P_CDPLANPRODOP);
                  END IF;

                  INSERT INTO ORDPRODUCAO
                       (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO, CDPROCFABRIC,
                         IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
                        DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
                        NRPEDIDO, NRITEMPED)
                  VALUES
                       (P_CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, P_CDPRODUTO,  P_CDPROCFABRIC,
                        P_IDSITORDPROD, P_IDTIPORDPROD, P_DTGERORDPROD, V_QTDEOP,
                        P_DTGERORDPROD, V_NRLOTEESTQ, V_NRSUBLOTE, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP,
                        P_NRPEDIDO, P_NRITEMPED);
               END LOOP;
            END IF;
         END IF;
      ELSE
         IF V_IDTPPROPOPF = 'U' THEN
            /* Gera o nmero do Lote de Produo */
            PRXLOTEPROD(P_CDFILIAL, P_DTVALIDADE, P_CDPRODUTO, V_NRLOTEESTQ);
               /* Gera o nmero da OP/SubOP */
            NOVO_CODIGO_SC('NRORDPROD'||P_CDFILIAL, V_SEQNRORDPROD, 1);
            V_NRORDPROD     := SUBSTR(V_SEQNRORDPROD, 11, 10);
            V_NRORDENASUBOP := '0';
            V_NRSUBLOTE     := ' ';

            SELECT
               MAX(NRLOTEESTQ)
            INTO
               V_NRLOTEEXIST
            FROM
               LOTE
            WHERE
               CDFILIAL     = P_CDFILIAL    AND
               CDPRODUTO    = P_CDPRODUTO   AND
               NRLOTEESTQ   = V_NRLOTEESTQ;

            IF V_NRLOTEEXIST IS NULL THEN
               INSERT INTO LOTE
                   (CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE,
                   DTENTRLOTE, DTVALILOTE, IDSTPRODLOTE, CDPLANPRODLT)
               VALUES
                   (P_CDFILIAL, V_NRLOTEESTQ, V_NRSUBLOTE, P_CDPRODUTO, 'I',
                    P_DTGERORDPROD, P_DTVALIDADE, '1', P_CDPLANPRODOP);
            END IF;

            INSERT INTO ORDPRODUCAO
                 (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDPRODUTO, CDPROCFABRIC,
                   IDSITORDPROD, IDTIPORDPROD, DTGERORDPROD, QTAPRODPREOP,
                  DTHRINIPREOP, NRLOTEESTQ, NRSUBLOTE, DSORDPROD, CDPLANPRODOP, IDCONFIRMAOP,
                  NRPEDIDO, NRITEMPED)
            VALUES
                 (P_CDFILIAL, V_NRORDPROD, V_NRORDENASUBOP, P_CDPRODUTO,  P_CDPROCFABRIC,
                  P_IDSITORDPROD, P_IDTIPORDPROD, P_DTGERORDPROD, P_QTAPRODPREOP,
                  P_DTGERORDPROD, V_NRLOTEESTQ, V_NRSUBLOTE, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP,
                  P_NRPEDIDO, P_NRITEMPED);
         END IF;
      END IF;
   END IF;

   /* Verifica se h algum semiacabado na composio deste produto */
   FOR C_SEMIACABADO IN (
                          SELECT I.CDPRODUTO   ,
                                 I.CDETAPAPROD ,
                                 I.CDPRODINSUMO,
                                 F.CDPROCFABRIC,
                                 (SYSDATE) AS DTVALIDADE,
                                 I.IDUTAPRREQET,
                                 I.IDSEMIACETAP,
                                 I.QTINSUMETAPA,
                                 I.QTRENDINSU  ,
                                 O.QTAPRODPREOP,
                                 QTPREVI_MATPRIMA(I.CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, O.QTAPRODPREOP) AS QTAINSUMPREOP
                            FROM ORDPRODUCAO O,
                                 PROCFABRICA F,
                                 INSUMETAPA  I
                           WHERE (I.IDSEMIACETAP = 'S'            )
                             AND (F.IDPROFABPADR = 'S'            )
                             AND (F.CDFILIAL     = I.CDFILIAL     )
                             AND (F.CDPRODUTO    = I.CDPRODINSUMO )
                             AND (O.CDFILIAL     = I.CDFILIAL     )
                             AND (O.CDPRODUTO    = I.CDPRODUTO    )
                             AND (O.CDPROCFABRIC = I.CDPROCFABRIC )
                             AND (O.CDFILIAL     = P_CDFILIAL     )
                             AND (O.NRORDPROD    = V_NRORDPROD    )
                             AND (O.NRSUBORDPROD = V_NRORDENASUBOP)
                             AND (O.CDPRODUTO    = P_CDPRODUTO   )
                             AND (O.CDPROCFABRIC = P_CDPROCFABRIC)
                           ORDER BY I.CDETAPAPROD, I.CDPRODINSUMO
                          ) LOOP
                          
      IF C_SEMIACABADO.QTAINSUMPREOP > 0 THEN
         V_QTSEMIACAB := 0;
  
         -- Consulta tabela temporria de estoque.
         BEGIN
            SELECT CDPRODUTO, QTESTOQUE
              INTO V_CDPRODEMANDA, V_QTESTOQUE
              FROM ESTSEMIACAB
             WHERE (CDFILIAL  = P_CDFILIAL)
               AND (NRPEDIDO  = P_NRPEDIDO)
               AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODEMANDA := '';
               V_QTESTOQUE    := 0;
         END;
  
         IF V_QTESTOQUE > 0 THEN
            V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP - V_QTESTOQUE;
  
            IF (V_QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP) > 0 THEN
               -- Altera a quantidade de estoque deste produto.
               UPDATE ESTSEMIACAB
                  SET QTESTOQUE  = V_QTESTOQUE - C_SEMIACABADO.QTAINSUMPREOP
                WHERE (CDFILIAL  = P_CDFILIAL)
                  AND (NRPEDIDO  = P_NRPEDIDO)
                  AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
            ELSE
               -- Zera a quantidade de estoque deste produto.
               UPDATE ESTSEMIACAB
                  SET QTESTOQUE  = 0
                WHERE (CDFILIAL  = P_CDFILIAL)
                  AND (NRPEDIDO  = P_NRPEDIDO)
                  AND (CDPRODUTO = C_SEMIACABADO.CDPRODINSUMO);
            END IF;
  
         ELSE
            V_QTSEMIACAB := C_SEMIACABADO.QTAINSUMPREOP;
         END IF;
  
         IF V_QTSEMIACAB > 0 THEN
                          
            /* Chama a mesma GERA_OP_SEMIACABADO recursivamente gerando OP para os semiacabados dos semiacabados */
            GERA_OP_SEMIACABADO(P_CDFILIAL, C_SEMIACABADO.CDPRODINSUMO, C_SEMIACABADO.CDPROCFABRIC, '1', '3', P_DTGERORDPROD, C_SEMIACABADO.DTVALIDADE,
                                C_SEMIACABADO.QTAINSUMPREOP, P_DSORDPROD, P_CDPLANPRODOP, P_IDCONFIRMAOP, P_NRPEDIDO, P_NRITEMPED);
         END IF;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_OP_SEMIACABADO','6.05.000'); END;
/